﻿@model InsightHub.Web.Areas.Author.Models.AuthorReportViewModel

@{
    ViewData["Title"] = "Create";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>Create new report</h1>

<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create" method="post" enctype="multipart/form-data">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <input asp-for="Description" class="form-control" />
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Industry" class="control-label"></label>
                <select asp-for="IndustryName" class="form-control" asp-items="ViewBag.Industry"></select>
            </div>
            <div>
                @Html.ListBoxFor(model => model.TagName, ViewBag.TagName as MultiSelectList,
               new { @class = "form-control", id = "vb", multiple = "multiple" })
            </div>

            <div class="container">
                <button type="button" class="btn btn-primary" data-toggle="collapse" data-target="#demo">Add new Tag</button>
                <div id="demo" class="collapse">
                    <div class="form-group">
                        <label for="usr">Name:</label>
                        <input type="text" class="form-control" id="NewTagName">
                    </div>

                    <input type="button" class="btn btn-outline-primary" value="Add" id="Save" />
                    <script>
                        $('#Save').click(function () {
                            var newTag = new Object();
                            newTag.Name = $("#NewTagName").val();
                            var tag = JSON.stringify(newTag);
                            $.ajax({
                                url: 'https://localhost:44333/api/tags',
                                type: 'POST',
                                dataType: "json",
                                data: tag,
                                contentType: 'application/json; charset=utf-8',
                                success: function (data) {
                                    toastr.options.positionClass = "toast-top-center";
                                    toastr.success('You have created a new tag!');
                                    $(function () {
                                        $(function () {
                                            var value = $("#NewTagName").val();
                                            var listBox = $("#vb");
                                            var option = $("<option />").val(value).html(value);
                                            listBox.append(option);
                                            $("#NewTagName").val("");
                                            return false;
                                        });
                                    });
                                },
                                error: function (xhr, textStatus, errorThrown) {
                                    toastr.options.positionClass = "toast-top-center";
                                    toastr.error('Tag with this name already exists!');
                                }
                            });
                        });
                    </script>
                </div>
            </div>



            <div class="form-group">
                <label asp-for="File" class="control-label"></label>
                <div class="control-label">
                    <div class="custom-file">
                        <input id="File" asp-for="File" class="form-control custom-file-input" />
                        <label class="custom-file-label">Choose file...</label>
                        <span asp-validation-for="File" class="text-danger"></span>
                    </div>
                </div>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-outline-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-area="Author" asp-controller="Reports" asp-action="ShowMyReports" class="btn btn-outline-primary">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
    <script>
        $("#File").change(function () {

            var val = $(this).val();

            switch (val.substring(val.lastIndexOf('.') + 1).toLowerCase()) {
                case 'pdf':
                    var fileName = $(this).val().split("\\").pop();
                    $(this).siblings(".custom-file-label").addClass("selected").html(fileName);
                    var size = $(this).get(0).files[0].size;
                    if (size > 25 * 1024 * 1024) {
                        toastr.options.positionClass = "toast-top-center";
                        toastr.error('File must be up to 25 MB.');
                    }
                    break;
                default:
                    $(this).val('');
                    toastr.options.positionClass = "toast-top-center";
                    toastr.warning('Please upload file in .pdf format!');
                    return false;
            }
        });
    </script>
}

